Subject: bug#24802: closed (Re: bug#24802: emacs -Q -nw loads cl-lib)

From: [email-masked] (GNU bug Tracking System)
Date: Sat, 02 Sep 2017 13:33:02 +0000

Your bug report

#24802: emacs -Q -nw loads cl-lib

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
24802: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=24802
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#24802: emacs -Q -nw loads cl-lib
From: Eli Zaretskii <[email-masked]>
To: [email-masked]
Cc: [email-masked]
Date: Sat, 02 Sep 2017 16:31:36 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

> Date: Mon, 31 Oct 2016 17:45:16 +0200
> From: Eli Zaretskii <[email-masked]>
> Cc: [email-masked]
> 
> > From: Glenn Morris <[email-masked]>
> > Cc: [email-masked]
> > Date: Sun, 30 Oct 2016 19:49:26 -0400
> > 
> > As you said in
> > 
> > http://lists.gnu.org/archive/html/emacs-devel/2015-10/msg00095.html
> > 
> >     Up until now, the rules for pre-loading package X were that either
> >     (a) some preloaded package requires X, or (b) X will be
> >     auto-loaded at the beginning of every session by some very
> >     frequent operation, like visiting the first file or creating a
> >     window or a frame.
> > 
> > Here we have case b), without needing any operation at all.
> > 
> > OK, it's not "every session", it's "every -nw session in an
> > xterm-like terminal", but IMO the same should apply.
> > 
> > [1] I don't count the actual term/*.el files themselves in this,
> > because those that aren't preloaded have traditionally been trivial.
> > Perhaps xterm.el has become so large, and is used (I guess) in such a
> > large fraction of without-x builds, that it should be preloaded in
> > such builds, as x-win.el is in with-x builds. I think that's a
> > separate issue though. It would however make the issue in this report
> > obvious.
> 
> That's exactly my line of reasoning: as long as we don't preload
> xterm.el, we shouldn't regard its loading of other files a problem.

In any case, your recipe yields nil with the current master, so even
if you disagree with the above reasoning, the original problem is now
gone, and I'm therefore closing this bug report.

Thanks.

Subject: emacs -Q -nw loads cl-lib
From: Glenn Morris <[email-masked]>
To: [email-masked]
Date: Wed, 26 Oct 2016 12:40:16 -0400
List-Id: <debbugs-submit.debbugs.gnu.org>

Package: emacs
Version: 26.0.50

Current trunk on GNU/Linux in an xterm:

emacs -Q -nw
(featurep 'cl-lib)  -> t

I believe this is because term/xterm.el now requires cl-lib at run-time.

You might want to consider:

i) Preload cl-lib - see previous discussions in list archives.

ii) Make term/*.el subject to same rules as files that are explicitly
listed in loadup.el - ie no requirements beyond those of loadup.